with Interfaces; use Interfaces;

package body CosNotifyChannelAdmin_EventChannel_Hash is

   P : constant array (0 .. 3) of Natural :=
     (1, 4, 5, 14);

   T1 : constant array (0 .. 3) of Unsigned_8 :=
     (29, 38, 43, 17);

   T2 : constant array (0 .. 3) of Unsigned_8 :=
     (42, 1, 15, 2);

   G : constant array (0 .. 46) of Unsigned_8 :=
     (0, 20, 0, 0, 0, 16, 0, 0, 18, 0, 6, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
      0, 9, 4, 0, 21, 12, 12, 0, 0, 8, 22, 0, 0, 10, 15, 11, 7, 0, 11, 0, 1,
      13, 0, 16, 5);

   function Hash (S : String) return Natural is
      F : constant Natural := S'First - 1;
      L : constant Natural := S'Length;
      F1, F2 : Natural := 0;
      J : Natural;
   begin
      for K in P'Range loop
         exit when L < P (K);
         J  := Character'Pos (S (P (K) + F));
         F1 := (F1 + Natural (T1 (K)) * J) mod 47;
         F2 := (F2 + Natural (T2 (K)) * J) mod 47;
      end loop;
      return (Natural (G (F1)) + Natural (G (F2))) mod 23;
   end Hash;

end CosNotifyChannelAdmin_EventChannel_Hash;
